<?php
//
// $Id: test_form_page.php, v 0.00 Sun Feb 21 2010 18:09:03 GMT+0000 (IST) Francis Crossen $
//

/**
* A page controller
*
* @package    Tina-MVC
* @subpackage Tina-Sample-Apps
* @author     Francis Crossen <francis@crossen.org>
*/

/**
* An example of how to use tina_mvc_form_helper_class
*
* Access it at: /tina-mvc-for-wordpress/test-form
*
* @package    Tina-MVC
* @subpackage Tina-Sample-Apps
* @uses         test_form_view.php the example_mvc view file
* @author     Francis Crossen <francis@crossen.org>
*/
class test_form_page extends tina_mvc_base_page_class {
    
    function __construct( $request ) {
        
        parent::__construct(  $request );
        
        // set up the form
        $f = new tina_mvc_form_helper_class( 'test-form' );
        
        // add some fields
        $f->add_field( 'test_field_text', 'text', 'Test field Caption', $db_table='NONE', $db_field=false, 'the default value', $extraAttrib='' );
        $_rules = array( 'required'=>NULL, 'min_strlen'=>20 );
        
        $f->add_validation_rules('test_field_text', $_rules );
//        $f->add_validation_rule('test_field text', 'regexp', 'some parameters' );
        
        $f->add_field( 'test-field-text-2', 'text' );
            
        $f->add_field( 'test-field-password', 'password' );
        
        $f->add_field( 'test-field0checkbox', 'checkbox', 'Test checkbox Caption', $db_table='NONE', $db_field=false, 'this is checked' );

        $f->add_field( 'test-field-radio', 'radio', '', 'NONE', false, 'forth option selected' );
        
        $radio_options = array( // display_value => post_value
            'first option' => 'foirst option value',
            'second option' => 'sec option value',
            'third option' => 'turd option value',
            '44444 option selected' => 'forth option selected'
        );
        $f->add_radio_options( 'test-field-radio' , $radio_options, 'forth option selected');
        
        $f->add_field( 'test_field-hidden', 'hidden', NULL, $db_table='NONE', $db_field=false, 'whatever value' );
        
        $f->add_field( 'test-field-select', 'select', '', 'NONE', false, '333' );
        $select_options = array( // display_value => post_value
            'first option' => '111',
            'second option' => '222',
            'third option selected' => '333',
            'fourth option' => '444'
        );
        $f->add_select_options( 'test-field-select' , $select_options );        
        
        $dummy_table_data = array( 'test_field' => 'test_field value', 'test-field2' => 'test-field2 value', 'non-existant field' => 'non-existant field value', 'test-field3' => 'SHOULDNT SEE THIS' );
        
        $f->add_field( 'test_field-textarea', 'textarea', 'Test field Textarea Caption', $db_table='NONE', $db_field=false, "Some text in the textarea blah, humbug." );
        
        $f->add_field( 'submit-button', 'submit', 'Send her on...', 'NONE', false, 'the-value-submitted-when-we-submit' );
        
        $f->add_field( 'reset-button', 'reset', 'DON\'T Send her on...', 'NONE', false, 'the-value-submitted-when-we-reset' );
        
        $f->load_field_data_array( 'NONE', $dummy_table_data );        
        
        $f->build_form();    // this also checks for validation errors and if posted...
     
        if( $tbl = $f->get_table_data() ) { // returns FALSE if there were validation errors...
            
            $this->set_post_title('My Test Form (submitted)');
            $post_content = 'Here\'s what was POST\'d:<br>'.htmlentities(print_r($tbl,1));
            
        }
        else {
            
            $this->set_post_title('My Test Form');
            $post_content = $f->get_form_html();
            
        }

        $this->set_post_content( $post_content );

        
    }

}








?>
